LOGIND.CONF(5)

NAME
logind.conf, logind.conf.d - Login manager configuration files

SYNOPSIS

/etc/elogind/logind.conf

/etc/elogind/logind.conf.d/*.conf

/etc/elogind/sleep.conf

/etc/elogind/sleep.conf.d/*.conf

DESCRIPTION

These files configures various parameters of elogind.

OPTIONS

All login options are configured in the "[Login]" section, system sleep options are configured in the "[Sleep]" section.

The file /etc/elogind/sleep.conf and the files in /etc/elogind/sleep.conf.d/*.conf only have a "[Sleep]" section.

  [Login] section:

KillUserProcesses=
    Takes a boolean argument. Configures whether the processes of a user should be killed when the user logs out. If true, the processes listed in their session cgroup will be terminated. If false, the session cgroup is ignored but see the options KillOnlyUsers= and KillExcludeUsers= below.

    Note that setting KillUserProcesses=yes will break tools like screen(1) and tmux(1), unless they are moved out of the session scope.

KillOnlyUsers=, KillExcludeUsers=
    These settings take space-separated lists of usernames that override the KillUserProcesses= setting. A user name may be added to KillExcludeUsers= to exclude the processes in the session scopes of that user from being killed even if KillUserProcesses=yes is set. If KillExcludeUsers= is not set, the "root" user is excluded by default. KillExcludeUsers= may be set to an empty value to override this default. If a user is not excluded, KillOnlyUsers= is checked next. If this setting is specified, only the processes in the session scopes of those users will be killed. Otherwise, users are subject to the KillUserProcesses=yes setting.

IdleAction=
    Configures the action to take when the system is idle. Takes one of "ignore", "poweroff", "reboot", "halt", "kexec", "suspend", "hibernate", "hybrid-sleep", "suspend-then-hibernate", and "lock". Defaults to "ignore".

    Note that this requires that user sessions correctly report the idle status to the system. The system will execute the action after all sessions report that they are idle, no idle inhibitor lock is active, and subsequently, the time configured with IdleActionSec= (see below) has expired.

IdleActionSec=
    Configures the delay after which the action configured in IdleAction= (see above) is taken after the system is idle.

InhibitDelayMaxSec=
    Specifies the maximum time a system shutdown or sleep request is delayed due to an inhibitor lock of type "delay" being active before the inhibitor is ignored and the operation executes anyway. Defaults to 5.

UserStopDelaySec=, HandlePowerKey=, HandleSuspendKey=, HandleHibernateKey=, HandleLidSwitch=, HandleLidSwitchExternalPower=, HandleLidSwitchDocked=
    Specifies how long to keep the user record around for a user after they logged out fully. If set to zero, the user is terminated immediately when the last session of the user has ended. Defaults to 10s. Controls how logind shall handle the system power and sleep keys and the lid switch to trigger actions such as system power-off or suspend. Can be one of "ignore", "poweroff", "reboot", "halt", "kexec", "suspend", "hibernate", "hybrid-sleep", "suspend-then-hibernate", and "lock". If "ignore", logind will never handle these keys. If "lock", all running sessions will be screen-locked; otherwise, the specified action will be taken in the respective event. Only input devices with the "power-switch" udev tag will be watched for key/lid switch events. HandlePowerKey= defaults to "poweroff". HandleSuspendKey= and HandleLidSwitch= default to "suspend". HandleLidSwitchExternalPower= is completely ignored by default (for backwards compatibility) — an explicit value must be set before it will be used to determine behaviour. HandleLidSwitchDocked= defaults to "ignore". HandleHibernateKey= defaults to "hibernate". If the system is inserted in a docking station, or if more than one display is connected, the action specified by HandleLidSwitchDocked= occurs; if the system is on external power the action (if any) specified by HandleLidSwitchExternalPower= occurs; otherwise the HandleLidSwitch= action occurs.

    A different application may disable logind's handling of system power and sleep keys and the lid switch by taking a low-level inhibitor lock ("handle-power-key", "handle-suspend-key", "handle-hibernate-key", "handle-lid-switch"). This is most commonly used by graphical desktop environments to take over suspend and hibernation handling, and to use their own configuration mechanisms. If a low-level inhibitor lock is taken, logind will not take any action when that key or switch is triggered and the Handle*= settings are irrelevant.

PowerKeyIgnoreInhibited=, SuspendKeyIgnoreInhibited=, HibernateKeyIgnoreInhibited=, LidSwitchIgnoreInhibited=
    Controls whether actions that elogind takes when the power and sleep keys and the lid switch are triggered are subject to high-level inhibitor locks ("shutdown", "sleep", "idle"). Low level inhibitor locks ("handle-power-key", "handle-suspend-key", "handle-hibernate-key", "handle-lid-switch"), are always honored, irrespective of this setting.

    These settings take boolean arguments. If "no", the inhibitor locks taken by applications are respected. If "yes", "shutdown", "sleep", and "idle" inhibitor locks are ignored. PowerKeyIgnoreInhibited=, SuspendKeyIgnoreInhibited=, and HibernateKeyIgnoreInhibited= default to "no". LidSwitchIgnoreInhibited= defaults to "yes". This means that when elogind is handling events by itself (no low level inhibitor locks are taken by another application), the lid switch does not respect suspend blockers by default, but the power and sleep keys do.

HoldoffTimeoutSec=
    Specifies a period of time after system startup or system resume in which elogind will hold off on reacting to lid events. This is required for the system to properly detect any hotplugged devices so lid events can be ignored if external monitors or docks are connected. If set to 0, elogind will always react immediately, possibly before the kernel fully probed all hotplugged devices. This is safe, as long as you do not care for devices that have been plugged or unplugged while the system was off. Defaults to 30s.

RuntimeDirectorySize=
    Sets the size limit on the $XDG_RUNTIME_DIR runtime directory for each user who logs in. Takes a size in bytes, optionally suffixed with the usual K, G, M, and T suffixes, to the base 1024 (IEC). Alternatively, a numerical percentage suffixed by "%" may be specified, which sets the size limit relative to the amount of physical RAM. Defaults to 10%. Note that this size is a safety limit only. As each runtime directory is a tmpfs file system, it will only consume as much memory as is needed.

RuntimeDirectoryInodesMax=
    Sets the limit on number of inodes for the $XDG_RUNTIME_DIR runtime directory for each user who logs in. Takes a number, optionally suffixed with the usual K, G, M, and T suffixes, to the base 1024 (IEC). Defaults to RuntimeDirectorySize= divided by 4096. Note that this size is a safety limit only. As each runtime directory is a tmpfs file system, it will only consume as much memory as is needed.

InhibitorsMax=
    Controls the maximum number of concurrent inhibitors to permit. Defaults to 8192 (8K).

SessionsMax=
    Controls the maximum number of concurrent user sessions to manage. Defaults to 8192 (8K). Depending on how the pam_elogind.so module is included in the PAM stack configuration, further login sessions will either be refused, or permitted but not tracked by elogind.

RemoveIPC=
    Controls whether System V and POSIX IPC objects belonging to the user shall be removed when the user fully logs out. Takes a boolean argument. If enabled, the user may not consume IPC resources after the last of the user's sessions terminated. This covers System V semaphores, shared memory and message queues, as well as POSIX shared memory and message queues. Note that IPC objects of the root user and other system users are excluded from the effect of this setting. Defaults to "yes".

  [Sleep] section:

loginctl supports four general power-saving modes:

suspend
    A low-power state where execution of the OS is paused, and complete power loss might result in lost data, and which is fast to enter and exit. This corresponds to suspend, standby, or freeze states as understood by the kernel.

hibernate
    A low-power state where execution of the OS is paused, and complete power loss does not result in lost data, and which might be slow to enter and exit. This corresponds to the hibernation as understood by the kernel.

hybrid-sleep
    A low-power state where execution of the OS is paused, which might be slow to enter, and on complete power loss does not result in lost data but might be slower to exit in that case. This mode is called suspend-to-both by the kernel.

suspend-then-hibernate
    Enter suspend state with a timeout that will activate hibernate later.

Enabling/disabling power-saving modes:

AllowSuspend=
    If this option is set to "no", elogind will refuse to suspend the machine.

AllowHibernation=
    If this option is set to "no", elogind will refuse to hibernate the machine.

AllowSuspendThenHibernate=
    If this option is set to "no", elogind will refuse to suspend and then hibernate the machine. For this power-saving mode to work, both AllowSuspend= and AllowHibernation= must be set to "yes".

AllowHybridSleep=
    If this option is set to "no", elogind will refuse to put the machine into hybrid sleep.

The power-saving modes and states can be controlled as follows:

SuspendMode=
    The string, if set, to be written to /sys/power/mem_sleep by elogind. More than one value can be specified by separating multiple values with whitespace. They will be tried in turn, until one is written without error. If neither succeeds, the operation will be aborted.

    The folowing modes might be written to /sys/power/mem_sleep:

    s2idle
        This is a generic, pure software, light-weight variant of system suspend (also referred to as S2I or suspend-to-idle). It allows more energy to be saved relative to runtime idle by freezing user space, suspending the timekeeping and putting all I/O devices into low-power states (possibly lower-power than available in the working state), such that the processors can spend time in their deepest idle states while the system is suspended.

        The system is woken up from this state by in-band interrupts, so theoretically any devices that can cause interrupts to be generated in the working state can also be set up as wakeup devices for s2idle.

    shallow
        This state, if supported, offers moderate, but real, energy savings, while providing a relatively straightforward transition back to the working state. No operating state is lost (the system core logic retains power), so the system can go back to where it left off easily enough.

        In addition to freezing user space, suspending the timekeeping and putting all I/O devices into low-power states, which is done for s2idle too, nonboot CPUs are taken offline and all low-level system functions are suspended during transitions into this state. For this reason, it should allow more energy to be saved relative to s2idle, but the resume latency will generally be greater than for that state.

        The set of devices that can wake up the system from this state usually is reduced relative to s2idle and it may be necessary to rely on the platform for setting up the wakeup functionality as appropriate.

    deep
        This state (also referred to as STR or S2RAM), if supported, offers significant energy savings as everything in the system is put into a low-power state, except for memory, which should be placed into the self-refresh mode to retain its contents. All of the steps carried out when entering shallow are also carried out during transitions to S2RAM. Additional operations may take place depending on the platform capabilities. In particular, on ACPI-based systems the kernel passes control to the platform firmware (BIOS) as the last step during S2RAM transitions and that usually results in powering down some more low-level components that are not directly controlled by the kernel.

        The state of devices and CPUs is saved and held in memory. All devices are suspended and put into low-power states. In many cases, all peripheral buses lose power when entering S2RAM, so devices must be able to handle the transition back to the "on" state.

        On ACPI-based systems S2RAM requires some minimal boot-strapping code in the platform firmware to resume the system from it. This may be the case on other platforms too.

        The set of devices that can wake up the system from S2RAM usually is reduced relative to s2idle and shallow and it may be necessary to rely on the platform for setting up the wakeup functionality as appropriate.

HibernateMode=, HybridSleepMode=
    The string, if set, to be written to /sys/power/disk by elogind. More than one value can be specified by separating multiple values with whitespace. They will be tried in turn, until one is written without error. If neither succeeds, the operation will be aborted.

    The chosen value controls the operating mode of hibernation (Suspend-to-Disk). Specifically, it tells the kernel what to do "after" creating a hibernation image.

    The folowing modes might be written to /sys/power/disk:

    platform
        Put the system into a special low-power state (e.g. ACPI S4) to make additional wakeup options available and possibly allow the platform firmware to take a simplified initialization path after wakeup.

        It is only available if the platform provides a special mechanism to put the system to sleep after creating a hibernation image (platforms with ACPI do that as a rule, for example).

    shutdown
        Power off the system.

    reboot
        Reboot the system (useful for diagnostics mostly).

    suspend
        Hybrid system suspend. Put the system into the suspend sleep state selected through the SuspendMode= value described above. If the system is successfully woken up from that state, discard the hibernation image and continue. Otherwise, use the image to restore the previous state of the system.

        It is available if system suspend is supported.

    test_resume
        Diagnostic operation. Load the image as though the system had just woken up from hibernation and the currently running kernel instance was a restore kernel and follow up with full system resume.

SuspendState=, HibernateState=, HybridSleepState=
    The string to be written to /sys/power/state by elogind. More than one value can be specified by separating multiple values with whitespace. They will be tried in turn, until one is written without error. If neither succeeds, the operation will be aborted.

    /sys/power/state contains a list of strings representing sleep states supported by the kernel. Writing one of these strings into it causes the kernel to start a transition of the system into the sleep state represented by that string.

    In particular, the "disk", "freeze" and "standby" strings represent the "hibernation", "suspend-to-idle (s2idle)" and "standby (shallow)" sleep states, respectively.

    The "mem" string is interpreted in accordance with the value written by SuspendMode into the /sys/power/mem_sleep file described above.

HibernateDelaySec=
    The amount of seconds the machine will remain suspended before waking up and going into hibernation, after the suspend-then-hibernate mode has been entered.

Executing optional executables when executing power/sleep commands:

AllowPowerOffInterrupts=, BroadcastPowerOffInterrupts=
    When power actions are allowed to be interrupted by setting AllowPowerOffInterrupts to "yes", elogind will, if any of the hook scripts in [/usr]/lib[64]/elogind/system-shutdown/ or /etc/elogind/system-shutdown/ fails, interrupt and cancel the power action. When this happens, elogind will broadcast the cancellation, unless BroadcastPowerOffInterrupts is set to "no". See loginctl(1) for more information about hook directories.

AllowSuspendInterrupts=, BroadcastSuspendInterrupts=
    When suspend/hibernate actions are allowed to be interrupted by setting AllowSuspendInterrupts to "yes", elogind will, if any of the hook script in [/usr]/lib[64]/elogind/system-sleep/ or /etc/elogind/system-sleep/ fails, interrupt and cancel the suspend action. When this happens, elogind will broadcast the cancellation, unless BroadcastSuspendInterrupts is set to "no". See loginctl(1) for more information about hook directories.

Optional hardware control:

HandleNvidiaSleep=
    If the file /proc/driver/nvidia/suspend exists, elogind will write either "suspend" when suspending, or "hibernate" when one of the other power-saving modes is entered, into it. Additionally elogind will try to switch the current VT to 63 before putting the Nvidia card to sleep. After resuming from suspend/hibernate, elogind will write "resume" into the Nvidia suspend file, and switches the VT back to where it was before suspending the card.

    Using the /proc/driver/nvidia/suspend is considered experimental by Nvidia, and should only be used if it is neccessary, and the official /usr/bin/nvidia-sleep.sh can not be used from a system-sleep hook script for some reason. Please read the Nvidia power management guide[1] for more information

SEE ALSO

elogind(8), loginctl(1),

NOTES

1.  Nvidia power management guide
    https://download.nvidia.com/XFree86/Linux-x86_64/455.38/README/powermanagement.html